package cubi;

import javax.media.opengl.GL2;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLEventListener;
import javax.media.opengl.glu.GLU;

import com.jogamp.opengl.util.gl2.GLUT;

public class GLRenderer implements GLEventListener {

	double yOss = -50;
	int width = 800, height = 600;

	@Override
	public void init(GLAutoDrawable drawable) {
		GL2 gl = drawable.getGL().getGL2();

		float[] ambiente = new float[] { 1, 1, 1, 1 };
		float[] diffusa = new float[] { 1, 1, 1, 1 };
		float[] speculare = new float[] { 1, 1, 1, 1 };
		float[] posizione = new float[] { 0, 10, 10, 1 };

		// imposta le caratteristiche della sorgente di luce 0
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_AMBIENT, ambiente, 0);
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_DIFFUSE, diffusa, 0);
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_SPECULAR, speculare, 0);
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_POSITION, posizione, 0);
		// attiva la sorgente di luce 0
		gl.glEnable(GL2.GL_LIGHT0);
		// attiva l'iluminazione
		gl.glEnable(GL2.GL_LIGHTING);
		// attiva il test di profondità per disegnare solo parti visibili
		gl.glEnable(GL2.GL_DEPTH_TEST);
		// imposta il colore di sfondo
		gl.glClearColor(0, 0, 0.1f, 0);
	}

	@Override
	public void dispose(GLAutoDrawable drawable) {
	}

	@Override
	public void display(GLAutoDrawable drawable) {
		GL2 gl = drawable.getGL().getGL2();
		GLU glu = new GLU();
		GLUT glut = new GLUT();

		// imposta la matrice di trasformazione per la proiezione
		gl.glMatrixMode(GL2.GL_PROJECTION);
		gl.glLoadIdentity();
		glu.gluPerspective(45, (float) width / height, 1, 50);
		glu.gluLookAt(5, yOss, 0, 0, 0, 0, 0, 0, 1);

		// imposta la matrice di trasformazione per gli oggetti
		gl.glMatrixMode(GL2.GL_MODELVIEW);
		gl.glLoadIdentity();
		// cancella l'immagine e il buffer per il test di profondità
		gl.glClear(GL2.GL_COLOR_BUFFER_BIT | GL2.GL_DEPTH_BUFFER_BIT);

		for (int x = -10; x <= 10; x++)
			for (int y = -10; y <= 10; y++)
				for (int z = -10; z <= 10; z++) {
					gl.glLoadIdentity();
					gl.glTranslated(x, y, z);
					glut.glutSolidCube(0.2f);
				}
		yOss += 1.0;
	}

	@Override
	public void reshape(GLAutoDrawable drawable, int x, int y, int w, int h) {
		GL2 gl = drawable.getGL().getGL2();
		GLU glu = new GLU();

		width = w;
		height = h;
		// imposta la matrice di trasformazione per la proiezione
		gl.glMatrixMode(GL2.GL_PROJECTION);
		gl.glLoadIdentity();
		glu.gluPerspective(45, (float) w / h, 1, 50);
		glu.gluLookAt(5, yOss, 0, 0, 0, 0, 0, 0, 1);

		// imposta la matrice di trasformazione per gli oggetti
		gl.glMatrixMode(GL2.GL_MODELVIEW);
		gl.glLoadIdentity();
	}

}